#!/bin/bash
# skript na konverziu slovnika PC Translator (LangSoft) do formatu StarDict
# jose (jose1711 -at- gmail -dot- com - June 2006)
if [ ! -f ancs.txt ]; then
	echo "Chyba subor so slovnikovou databazou (ancs.txt). Koncim."
	exit
fi
if [ $# -ne 1 ]; then
        echo -n "pouzitie: "
        echo $0" kod jazyka (en|pl|lt|sk)"
        exit
fi
SYSENCODING=$LC_ALL
export LC_ALL=cs_CZ.ISO-8859-2
echo -n "Vytvaram zoznam cudzojazycnych vyrazov..."
case $1 in
        en) echo "anglictina"
	    sed -e "s/\([^\d1\d2]*\)[\d1\d2][^\d1\d2]*.*/\1/" < ancs.txt | grep -v '^$' > foreign.txt;;
        pl) echo "polstina"
	    sed -e "s/\([^\d1\d2]*\)[\d1\d2][^\d1\d2]*.*/\1/" ancs.txt | tr '\213\221\222\223\225\227\232\236\237\240\241\243\246\247\250\253\254\255\257\260\261\266\270\273\275\277\301\306\307\310\311\313\315\316HIMPUVWY\\]^abcflnquw}\201' 'abcdefghijklmnoprstuvwxyzBCDEFGHIJKLMNOPRSTUWZ' | grep -v "^$" > foreign.txt;;
        lt) echo "latincina"
	    sed -e "s/\([^\d1\d2]*\)[\d1\d2][^\d1\d2]*.*/\1/" < ancs.txt | tr '\213\214\222\223\227\232\234\237\240\241\243\244\246\247\250\254\255\260\261\263\266\267\270\271\273\277\301\302\304\306\307\310\311\312\313HIPVWY]^bfqw|}~\201' 'abcdefghijklmnopqrstuvwxyzBCEGHIKLMOSUVWXZ' | grep -v '^$' > foreign.txt;;
        sk) echo "slovencina"
	    sed -e "s/\([^\d1\d2]*\)[\d1\d2][^\d1\d2]*.*/\1/" ancs.txt | tr '\1\170\171\172\173\174\175\176\177\200\201\202\203\204\205\207\210\211\212\213\214\215\216\217\220\221\222\223\225\226\227\230\231\232\233\234\235\236\237\240\242\243\244\245\246\247\250ABDEFGHIJKLMNOPQRSTWXZ^_`bcdeghklmnopq' '\tabcdefghijklmnopqrstuvwxyzABCDEFGH\6IJKLMNOPQRSTUVWXYZ' | sed -e "s/\o206/ch/g" | sed -e "s/\d6/Ch/g" | grep -v "^$" > foreign.txt;;
        *) echo "kod jazyka nie je podporovany";exit;;
esac
echo "Vytvaram zoznam ceskych vyrazov..."
# psmeno Ch (kdovan ako O) doasne prekdujeme na 0x06
sed -e "s/\d1/\d2\t/g" ancs.txt | sed -e "s/[^\d2]*\d2\([^\d2]*\).*/\1/" | tr '' '\n'  | tr '\1\170\171\172\173\174\175\176\177\200\201\202\203\204\205\207\210\211\212\213\214\215\216\217\220\221\222\223\225\226\227\230\231\232\233\234\235\236\237\240\242\243\244\245\246\247\250ABDEFGHIJKLMNOPQRSTWXZ^_`bcdeghklmnopq' '\tabcdefghijklmnopqrstuvwxyzABCDEFGH\6IJKLMNOPQRSTUVWXYZ' |  sed -e "s/\o206/ch/g" | sed -e "s/\d6/Ch/g" > czech.txt 
echo "Vytvaram zoznam typov..."
sed -e "s/[^\d1\d2]*[\d1\d2][^\d1\d2]*\d1\([^\d1]*\).*/\1/" < ancs.txt | tr '&' 'X' | grep -v '^$' > type.txt
echo "Vytvaram slovnikove udaje pre oba smery..."
exit
python merge_dict.py

rm foreign.txt czech.txt type.txt
iconv -f iso8859-2 -t utf8 -o $1"-cz-dict.txt" en-cz-dictionary.txt
iconv -f iso8859-2 -t utf8 -o "cz-"$1"-dict.txt" cz-en-dictionary.txt
mv $1-cz-dict.txt $1-cz-dictionary.txt
mv cz-$1-dict.txt cz-$1-dictionary.txt
echo "Vytvaram data pre StarDict slovnik ..."
for slovnik in $1"-cz-dictionary.txt" "cz-"$1"-dictionary.txt" 
	do echo -ne "StarDict's dict ifo file
version=2.4.2
wordcount=" >$slovnik.ifo
	echo $(./tabfile $slovnik | grep wordcount | sed -e "s/.*wordcount: \(.*\)$/\1/") >>$slovnik.ifo
	echo -ne "idxfilesize=" >>$slovnik.ifo
	echo $(ls -gGs $slovnik.idx | awk '{print $4}') >>$slovnik.ifo
	echo -ne "bookname=" >>$slovnik.ifo
	echo $(echo $slovnik | cut -c "-5") >>$slovnik.ifo
	echo -ne "author=LangSoft
email=some@e-mail.com
website=this dictionary's project websit link
description=converted to StarDict format by jose
date=2006.05.31
sametypesequence=g
" >>$slovnik.ifo
	done
echo "Skopirujte subory s priponou .ifo, .dict a .idx do /usr/share/stardict/dic/transl alebo ~/.stardict/dic/transl" 
rm $1-cz-dictionary.txt cz-$1-dictionary.txt
export LC_ALL=$SYSENCODING

